stages:
  - lint
  - build
  - test
  - coverage
  - deploy

variables:
  DOCKER_DRIVER: overlay2

lint:
  stage: lint
  image: rust:latest
  script:
    - rustup component add clippy
    - rustup component add rustfmt
    - cargo clippy -- -D warnings
    - cargo fmt -- --check

build:
  stage: build
  image: docker:latest
  services:
    - docker:dind
  script:
    - docker build -t my-rust-app .

test:
  stage: test
  image: rust:latest
  services:
    - postgres:12
    - rabbitmq:3-management
  variables:
    DATABASE_URL: "postgres://postgres:postgres@localhost:5432/postgres"
  before_script:
    - rustup component add rustfmt
    - rustup component add clippy
  script:
    - cargo test

coverage:
  stage: coverage
  image: rust:latest
  script:
    - cargo install grcov
    - sudo apt-get install llvm-tools-10
    - export CARGO_INCREMENTAL=0
    - export RUSTFLAGS="-Zinstrument-coverage"
    - export LLVM_PROFILE_FILE="your_name-%p-%m.profraw"
    - cargo build
    - cargo test
    - grcov . --binary-path ./target/debug/ -s . -t lcov --branch --ignore-not-existing -o lcov.info
    - bash <(curl -s https://codecov.io/bash) -f lcov.info

deploy:
  stage: deploy
  image: docker:latest
  services:
    - docker:dind
  script:
    - docker-compose up -d